import { Params as BootstrapParams } from './hooks/bootstrap';
import { Params as InitParams } from './hooks/init';
import { Params as DeathParams } from './hooks/death';
export { default as bootstrapHook, Params as BootstrapParams, } from './hooks/bootstrap';
export { default as initHook, Params as InitParams, } from './hooks/init';
export { default as deathHook, Params as DeathParams, } from './hooks/death';
export declare const hooks: {
    bootstrap: import("@spine/hook/HookAction").HookAction<any, BootstrapParams>;
    init: import("@spine/hook/HookActionSeries").HookActionSeries<any, InitParams>;
    death: import("@spine/hook/HookActionSync").HookActionSync<any, DeathParams>;
};
export declare function didDie(): boolean;
export declare function didBootstrap(): boolean;
export declare function bootstrap(): Promise<{
    bootstrap: void;
    init: void;
}>;
export declare function die(): Promise<void>;
export declare function dieSync(): void;
