"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.didDie = didDie;
exports.didBootstrap = didBootstrap;
exports.bootstrap = bootstrap;
exports.die = die;
exports.dieSync = dieSync;
Object.defineProperty(exports, "bootstrapHook", {
  enumerable: true,
  get: function get() {
    return _bootstrap2.default;
  }
});
Object.defineProperty(exports, "BootstrapParams", {
  enumerable: true,
  get: function get() {
    return _bootstrap2.Params;
  }
});
Object.defineProperty(exports, "initHook", {
  enumerable: true,
  get: function get() {
    return _init.default;
  }
});
Object.defineProperty(exports, "InitParams", {
  enumerable: true,
  get: function get() {
    return _init.Params;
  }
});
Object.defineProperty(exports, "deathHook", {
  enumerable: true,
  get: function get() {
    return _death.default;
  }
});
Object.defineProperty(exports, "DeathParams", {
  enumerable: true,
  get: function get() {
    return _death.Params;
  }
});
exports.hooks = void 0;

require("core-js/modules/es6.promise");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _bootstrap2 = _interopRequireWildcard(require("./hooks/bootstrap"));

var _init = _interopRequireWildcard(require("./hooks/init"));

var _death = _interopRequireWildcard(require("./hooks/death"));

var hooks = {
  bootstrap: _bootstrap2.default,
  init: _init.default,
  death: _death.default
};
exports.hooks = hooks;
var died = false;

function didDie() {
  return died;
}

var destroy = function destroy() {
  if (didDie()) {
    throw new Error('Dying has already started');
  }

  died = true;
};

var started = false;

function didBootstrap() {
  return started;
}

function bootstrap() {
  return _bootstrap.apply(this, arguments);
}

function _bootstrap() {
  _bootstrap = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    var bootstrap, init;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!didBootstrap()) {
              _context.next = 2;
              break;
            }

            throw new Error('Bootstrap has already started');

          case 2:
            started = true;
            _context.next = 5;
            return _bootstrap2.default.do({});

          case 5:
            bootstrap = _context.sent;
            _context.next = 8;
            return _init.default.do({});

          case 8:
            init = _context.sent;
            return _context.abrupt("return", {
              bootstrap: bootstrap,
              init: init
            });

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _bootstrap.apply(this, arguments);
}

function die() {
  return _die.apply(this, arguments);
}

function _die() {
  _die = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var results, promises, _arr, _i, pluginName, result;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            destroy();
            results = {};

            _death.default.do({
              async: true
            }, undefined, results);

            promises = [];
            _arr = Object.keys(results);

            for (_i = 0; _i < _arr.length; _i++) {
              pluginName = _arr[_i];
              result = results[pluginName];

              if (result instanceof Promise) {
                promises.push(result);
              }
            }

            _context2.next = 8;
            return promises;

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _die.apply(this, arguments);
}

function dieSync() {
  destroy();

  _death.default.do({
    async: false
  });
}
//# sourceMappingURL=index.js.map